
/* (C) Copyright 1984,85,86,87 Walter L. Peacock   All Rights Reserved   */
/*   P U T F P A T V . C  10/23/84                     */
/*    put formatted patient args into record.         */
/*----------------------------------------------------------------------------
 * putfpatv() is used by the demo programs to write variable length
 * patient records to the patient file
 *---------------------------------------------------------------------------*/

#include "cbtree.h"
#include "patrec.str"      /* patient record structure */

void putfpatv(fd, btcp, varlenpr)
int    fd;
BTC   *btcp;      /* relative record number   */
char  *varlenpr;         /* pointer to patient record structure */
{
   extern long lseek();

   if (btseekv(fd, btcp->btloc, btcp->btdtalen) == -1L)
      ckerror(- CK_SEEK, "PUTFPATV.C");
   if (write(fd, varlenpr, btcp->btdtalen) == ERR)
      ckerror(- CK_WRIT, "PUTFPAT.C");
}

uword patvar(buffer, pr)   /* raw patient record to variable length */

char *buffer;  /* where to put variable length record */
PATREC *pr;    /* pointer to raw patient record */

{
   uword total;

   strcpy(buffer, pr->lname);
   strcat(buffer, ", ");
   strcat(buffer, pr->fname);
   strcat(buffer, " ");
   strcat(buffer, pr->minit);
   strcat(buffer, "\n");
   total = strlen(pr->lname) + strlen(pr->fname) + strlen(pr->minit) + 4;

   strcat(buffer, pr->addr);
   strcat(buffer, "\n");
   total += strlen(pr->addr) + 1;

   strcat(buffer, pr->hphone);
   strcat(buffer, "\n");
   total += strlen(pr->hphone) + 1;

   strcat(buffer, pr->ssn);
   strcat(buffer, "\n");
   total += strlen(pr->ssn) + 1;

   return ((uword)(total + 1));  /* for NUL terminator */
}
